3 # Copyright (c) 2005 Junio C Hamano
6 # Keep the original TERM for say_color
9 # For repeatability, reset the environment to known value.
15 export LANG LC_ALL PAGER TERM TZ
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
35 unset GIT_EXTERNAL_DIFF
37 unset GIT_OBJECT_DIRECTORY
38 unset SHA1_FILE_DIRECTORIES
39 unset SHA1_FILE_DIRECTORY
41 export GIT_MERGE_VERBOSITY
42 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
43 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
50 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
52 echo "* warning: Some tests will not work if GIT_TRACE" \
53 "is set as to trace on STDERR ! *"
54 echo "* warning: Please set GIT_TRACE to something" \
55 "other than 1, 2 or true ! *"
59 # Each test should start with something like this, after copyright notices:
61 # test_description='Description of this test...
62 # This test checks if command xyzzy does the right thing...
65 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
66 TERM=$ORIGINAL_TERM &&
69 tput bold >/dev/null 2>&1 &&
70 tput setaf 1 >/dev/null 2>&1 &&
71 tput sgr0 >/dev/null 2>&1
78 -d|--d|--de|--deb|--debu|--debug)
80 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
82 -h|--h|--he|--hel|--help)
84 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
86 -q|--q|--qu|--qui|--quie|--quiet)
98 if test -n "$color"; then
104 error) tput bold; tput setaf 1;; # bold red
105 skip) tput bold; tput setaf 2;; # bold green
106 pass) tput setaf 2;; # green
107 info) tput setaf 3;; # brown
108 *) test -n "$quiet" && return;;
117 test -z "$1" && test -n "$quiet" && return
124 say_color error "error: $*"
133 test "${test_description}" != "" ||
134 error "Test script did not set test_description."
136 if test "$help" = "t"
138 echo "$test_description"
143 if test "$verbose" = "t"
147 exec 4>/dev/null 3>/dev/null
153 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
156 if test -z "${test_tick+set}"
160 test_tick=$(($test_tick + 60))
162 GIT_COMMITTER_DATE="$test_tick -0700"
163 GIT_AUTHOR_DATE="$test_tick -0700"
164 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
167 # You are not expected to call test_ok_ and test_failure_ directly, use
168 # the text_expect_* functions instead.
171 test_count=$(expr "$test_count" + 1)
172 say_color "" " ok $test_count: $@"
176 test_count=$(expr "$test_count" + 1)
177 test_failure=$(expr "$test_failure" + 1);
178 say_color error "FAIL $test_count: $1"
180 echo "$@" | sed -e 's/^/ /'
181 test "$immediate" = "" || { trap - exit; exit 1; }
186 test "$debug" = "" || eval "$1"
196 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
197 this_test="$this_test.$(expr "$test_count" + 1)"
199 for skp in $GIT_SKIP_TESTS
208 say_color skip >&3 "skipping test: $@"
209 test_count=$(expr "$test_count" + 1)
210 say_color skip "skip $test_count: $1"
219 test_expect_failure () {
221 error "bug in the test script: not 2 parameters to test-expect-failure"
224 say >&3 "expecting failure: $2"
226 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
236 test_expect_success () {
238 error "bug in the test script: not 2 parameters to test-expect-success"
241 say >&3 "expecting success: $2"
243 if [ "$?" = 0 -a "$eval_ret" = 0 ]
253 test_expect_code () {
255 error "bug in the test script: not 3 parameters to test-expect-code"
258 say >&3 "expecting exit code $1: $3"
260 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
270 # This is not among top-level (test_expect_success | test_expect_failure)
271 # but is a prefix that can be used in the test script, like:
273 # test_expect_success 'complain and die' '
275 # do something else &&
276 # test_must_fail git checkout ../outerspace
279 # Writing this as "! git checkout ../outerspace" is wrong, because
280 # the failure could be due to a segv. We want a controlled failure.
284 test $? -gt 0 -a $? -le 128
287 # Most tests can use the created repository, but some may need to create more.
288 # Usage: test_create_repo <directory>
289 test_create_repo () {
291 error "bug in the test script: not 1 parameter to test-create-repo"
295 cd "$repo" || error "Cannot setup test environment"
296 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
297 error "cannot run git init -- have you built things yet?"
298 mv .git/hooks .git/hooks-disabled
304 case "$test_failure" in
307 # cd .. && rm -fr trash
308 # but that means we forbid any tests that use their own
309 # subdirectory from calling test_done without coming back
310 # to where they started from.
311 # The Makefile provided will clean this test area so
312 # we will leave things as they are.
314 say_color pass "passed all $test_count test(s)"
318 say_color error "failed $test_failure among $test_count test(s)"
324 # Test the binaries we have just built. The tests are kept in
325 # t/ subdirectory and are run in trash subdirectory.
327 GIT_EXEC_PATH=$(pwd)/..
328 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
329 GIT_CONFIG=.git/config
330 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
332 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
334 test -d ../templates/blt || {
335 error "You haven't built things yet, have you?"
338 if ! test -x ../test-chmtime; then
339 echo >&2 'You need to build test-chmtime:'
340 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
347 test_create_repo $test
350 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
351 for skp in $GIT_SKIP_TESTS
354 for skp in $GIT_SKIP_TESTS
363 say_color skip >&3 "skipping test $this_test altogether"
364 say_color skip "skip all tests in $this_test"